build-psiphon-framework.sh 7.5 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207
  1. #!/usr/bin/env bash
  2. set -e -u -x
  3. if [ -z ${1+x} ]; then BUILD_TAGS=""; else BUILD_TAGS="$1"; fi
  4. # Modify this value as we use newer Go versions.
  5. GO_VERSION_REQUIRED="1.11.5"
  6. # Reset the PATH to macOS default. This is mainly so we don't execute the wrong
  7. # gomobile executable.
  8. PATH=/usr/local/bin:/usr/bin:/bin:/usr/sbin:/sbin:/usr/local/go/bin
  9. BASE_DIR=$(cd "$(dirname "$0")" ; pwd -P)
  10. cd ${BASE_DIR}
  11. # The location of the final framework build
  12. BUILD_DIR="${BASE_DIR}/build"
  13. # Ensure go is installed
  14. which go 2>&1 > /dev/null
  15. if [[ $? != 0 ]]; then
  16. echo "Go is not installed in the path, aborting"
  17. exit 1
  18. fi
  19. VALID_IOS_ARCHS="arm64 armv7 armv7s"
  20. VALID_SIMULATOR_ARCHS="x86_64"
  21. FRAMEWORK="Psi"
  22. INTERMEDIATE_OUPUT_DIR="${BASE_DIR}/PsiphonTunnel/PsiphonTunnel"
  23. INTERMEDIATE_OUPUT_FILE="${FRAMEWORK}.framework"
  24. FRAMEWORK_BINARY="${INTERMEDIATE_OUPUT_DIR}/${INTERMEDIATE_OUPUT_FILE}/Versions/A/${FRAMEWORK}"
  25. UMBRELLA_FRAMEWORK_XCODE_PROJECT=${BASE_DIR}/PsiphonTunnel/PsiphonTunnel.xcodeproj/
  26. # Exporting these seems necessary for subcommands to pick them up.
  27. export GOPATH=${PWD}/go-ios-build
  28. export PATH=${GOPATH}/bin:${PATH}
  29. # The GOPATH we're using is temporary, so make sure there isn't one from a previous run.
  30. rm -rf ${GOPATH}
  31. GOMOBILE_PINNED_REV=92f3b9caf7ba8f4f9c10074225afcba0cba47a62
  32. GOMOBILE_PATH=${GOPATH}/src/golang.org/x/mobile/cmd/gomobile
  33. TUNNEL_CORE_SRC_DIR=${GOPATH}/src/github.com/Psiphon-Labs/psiphon-tunnel-core
  34. PATH=${PATH}:${GOPATH}/bin
  35. mkdir -p ${GOPATH}
  36. if [[ $? != 0 ]]; then
  37. echo "FAILURE: mkdir -p ${GOPATH}"
  38. exit 1
  39. fi
  40. # Symlink the current source directory into GOPATH, so that we're building the
  41. # code in this local repo, rather than pulling from Github and building that.
  42. mkdir -p ${GOPATH}/src/github.com/Psiphon-Labs
  43. if [[ $? != 0 ]]; then
  44. echo "mkdir -p ${GOPATH}/src/github.com/Psiphon-Labs"
  45. exit 1
  46. fi
  47. ln -s "${BASE_DIR}/../.." "${GOPATH}/src/github.com/Psiphon-Labs/psiphon-tunnel-core"
  48. if [[ $? != 0 ]]; then
  49. echo "ln -s ../.. ${GOPATH}/src/github.com/Psiphon-Labs/psiphon-tunnel-core"
  50. exit 1
  51. fi
  52. mkdir -p ${INTERMEDIATE_OUPUT_DIR}
  53. if [[ $? != 0 ]]; then
  54. echo "FAILURE: mkdir -p ${INTERMEDIATE_OUPUT_DIR}"
  55. exit 1
  56. fi
  57. # arg: binary_path
  58. function strip_architectures() {
  59. valid_archs="${VALID_IOS_ARCHS} ${VALID_SIMULATOR_ARCHS}"
  60. ARCHS="$(lipo -info "$1" | rev | cut -d ':' -f1 | rev)"
  61. for ARCH in "${valid_archs}"; do
  62. if ! [[ "${valid_archs}" == *"$ARCH"* ]]; then
  63. echo "Stripping ARCH ${ARCH} from $1"
  64. lipo -remove "$ARCH" -output "$1" "$1"
  65. if [[ $? != 0 ]]; then
  66. echo "FAILURE: lipo $1"
  67. exit 1
  68. fi
  69. fi
  70. done
  71. return 0
  72. }
  73. # Check Go version
  74. GO_VERSION=$(go version | sed -E -n 's/.*go([0-9]\.[0-9]+(\.[0-9]+)?).*/\1/p')
  75. if [[ ${GO_VERSION} != ${GO_VERSION_REQUIRED} ]]; then
  76. echo "FAILURE: go version mismatch; require ${GO_VERSION_REQUIRED}; got ${GO_VERSION}"
  77. exit 1
  78. fi
  79. # Don't use -u, because this path points to our local repo, and we don't want it overridden.
  80. go get -d -v -tags "${BUILD_TAGS}" github.com/Psiphon-Labs/psiphon-tunnel-core/MobileLibrary/psi
  81. if [[ $? != 0 ]]; then
  82. echo "FAILURE: go get -d -v -tags "${BUILD_TAGS}" github.com/Psiphon-Labs/psiphon-tunnel-core/MobileLibrary/psi"
  83. exit 1
  84. fi
  85. #
  86. # Get and install gomobile, using our pinned revision
  87. #
  88. go get -u golang.org/x/mobile/cmd/gomobile
  89. cd ${GOPATH}/src/golang.org/x/mobile/cmd/gomobile
  90. git checkout master
  91. git checkout -b pinned ${GOMOBILE_PINNED_REV}
  92. go install
  93. ${GOPATH}/bin/gomobile init -v -x
  94. if [[ $? != 0 ]]; then
  95. echo "FAILURE: ${GOPATH}/bin/gomobile init"
  96. exit 1
  97. fi
  98. #
  99. # gomobile bind
  100. #
  101. # Ensure BUILD* variables reflect the tunnel-core repo
  102. cd ${TUNNEL_CORE_SRC_DIR}
  103. BUILDDATE=$(date +%Y-%m-%dT%H:%M:%S%z)
  104. BUILDREPO=$(git config --get remote.origin.url)
  105. BUILDREV=$(git rev-parse --short HEAD)
  106. GOVERSION=$(go version | perl -ne '/go version (.*?) / && print $1')
  107. GOMOBILEVERSION=$(${GOPATH}/bin/gomobile version | perl -ne '/gomobile version (.*?) / && print $1')
  108. # see DEPENDENCIES comment in MobileLibrary/Android/make.bash
  109. cd ${GOPATH}/src/github.com/Psiphon-Labs/psiphon-tunnel-core/MobileLibrary/psi
  110. DEPENDENCIES=$(echo -n "{" && GOOS=darwin go list -tags "${BUILD_TAGS}" -f '{{range $dep := .Deps}}{{printf "%s\n" $dep}}{{end}}' | GOOS=darwin xargs go list -tags "${BUILD_TAGS}" -f '{{if not .Standard}}{{.ImportPath}}{{end}}' | xargs -I pkg bash -c 'PKG=pkg && cd $GOPATH/src/$PKG && echo -n "\"$PKG\":\"$(git rev-parse --short HEAD)\","' | sed 's/,$/}/')
  111. LDFLAGS="\
  112. -s \
  113. -w \
  114. -X github.com/Psiphon-Labs/psiphon-tunnel-core/psiphon/common.buildDate=${BUILDDATE} \
  115. -X github.com/Psiphon-Labs/psiphon-tunnel-core/psiphon/common.buildRepo=${BUILDREPO} \
  116. -X github.com/Psiphon-Labs/psiphon-tunnel-core/psiphon/common.buildRev=${BUILDREV} \
  117. -X github.com/Psiphon-Labs/psiphon-tunnel-core/psiphon/common.goVersion=${GOVERSION} \
  118. -X github.com/Psiphon-Labs/psiphon-tunnel-core/psiphon/common.gomobileVersion=${GOMOBILEVERSION} \
  119. -X github.com/Psiphon-Labs/psiphon-tunnel-core/psiphon/common.dependencies=${DEPENDENCIES} \
  120. "
  121. echo ""
  122. echo "Variables for ldflags:"
  123. echo " Build date: ${BUILDDATE}"
  124. echo " Build repo: ${BUILDREPO}"
  125. echo " Build revision: ${BUILDREV}"
  126. echo " Go version: ${GOVERSION}"
  127. echo " Gomobile version: ${GOMOBILEVERSION}"
  128. echo ""
  129. # We're using a generated-code prefix to workaround https://github.com/golang/go/issues/18693
  130. # CGO_CFLAGS_ALLOW is to workaround https://github.com/golang/go/issues/23742 in Go 1.9.4
  131. CGO_CFLAGS_ALLOW="-fmodules|-fblocks" ${GOPATH}/bin/gomobile bind -v -x -target ios -prefix Go -tags="${BUILD_TAGS}" -ldflags="${LDFLAGS}" -o "${INTERMEDIATE_OUPUT_DIR}/${INTERMEDIATE_OUPUT_FILE}" github.com/Psiphon-Labs/psiphon-tunnel-core/MobileLibrary/psi
  132. rc=$?; if [[ $rc != 0 ]]; then
  133. echo "FAILURE: ${GOPATH}/bin/gomobile bind -target ios -tags="${BUILD_TAGS}" -ldflags="${LDFLAGS}" -o "${INTERMEDIATE_OUPUT_DIR}/${INTERMEDIATE_OUPUT_FILE}" github.com/Psiphon-Labs/psiphon-tunnel-core/MobileLibrary/psi"
  134. exit $rc
  135. fi
  136. strip_architectures "${FRAMEWORK_BINARY}"
  137. #
  138. # Do the outer framework build using Xcode
  139. #
  140. # Clean previous output
  141. rm -rf "${BUILD_DIR}"
  142. rm -rf "${BUILD_DIR}-SIMULATOR"
  143. # Build the outer framework for phones...
  144. xcodebuild clean build CODE_SIGN_IDENTITY="" CODE_SIGNING_REQUIRED=NO CODE_SIGN_ENTITLEMENTS="" CODE_SIGNING_ALLOWED="NO" -configuration Release -sdk iphoneos ONLY_ACTIVE_ARCH=NO -project ${UMBRELLA_FRAMEWORK_XCODE_PROJECT} CONFIGURATION_BUILD_DIR="${BUILD_DIR}"
  145. rc=$?; if [[ $rc != 0 ]]; then
  146. echo "FAILURE: xcodebuild iphoneos"
  147. exit $rc
  148. fi
  149. # ...and for the simulator.
  150. xcodebuild clean build CODE_SIGN_IDENTITY="" CODE_SIGNING_REQUIRED=NO CODE_SIGN_ENTITLEMENTS="" CODE_SIGNING_ALLOWED="NO" -configuration Release -sdk iphonesimulator ARCHS=x86_64 VALID_ARCHS=x86_64 ONLY_ACTIVE_ARCH=NO -project ${UMBRELLA_FRAMEWORK_XCODE_PROJECT} CONFIGURATION_BUILD_DIR="${BUILD_DIR}-SIMULATOR"
  151. rc=$?; if [[ $rc != 0 ]]; then
  152. echo "FAILURE: xcodebuild iphonesimulator"
  153. exit $rc
  154. fi
  155. # Add the simulator x86_64 binary into the main framework binary.
  156. lipo -create "${BUILD_DIR}/PsiphonTunnel.framework/PsiphonTunnel" "${BUILD_DIR}-SIMULATOR/PsiphonTunnel.framework/PsiphonTunnel" -output "${BUILD_DIR}/PsiphonTunnel.framework/PsiphonTunnel"
  157. rc=$?; if [[ $rc != 0 ]]; then
  158. echo "FAILURE: lipo create"
  159. exit $rc
  160. fi
  161. # Delete the temporary simulator build files.
  162. rm -rf "${BUILD_DIR}-SIMULATOR"
  163. # Jenkins loses symlinks from the framework directory, which results in a build
  164. # artifact that is invalid to use in an App Store app. Instead, we will zip the
  165. # resulting build and use that as the artifact.
  166. cd "${BUILD_DIR}"
  167. zip --recurse-paths --symlinks build.zip * --exclude "*.DS_Store"
  168. echo "BUILD DONE"